
package de.ivu.elect.presentation.veranstaltung.exchange;

import static org.apache.commons.lang3.StringUtils.isBlank;

import java.util.List;

import javax.annotation.Nullable;
import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.datei.entity.DateiImportBerichtCustomData;
import de.ivu.elect.business.exchange.control.AbstractImporter;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.veranstaltung.boundary.VeranstaltungImporter;
import de.ivu.elect.business.veranstaltung.control.VeranstaltungExchangeContext;
import de.ivu.elect.business.veranstaltung.entity.Veranstaltung;
import de.ivu.elect.jee.faces.PreConditionCheck;
import de.ivu.elect.presentation.View;
import de.ivu.elect.presentation.exchange.AbstractImportSearchView;
import de.ivu.elect.presentation.exchange.ImportDescription;
import de.ivu.elect.presentation.gebietsbaum.GebietNummerFormatter;
import de.ivu.elect.presentation.hilfe.OnlineHilfeId;

@OnlineHilfeId(value = "654", mehrfachVergebenOk = true)
@Named(VeranstaltungImportSearchView.COMPONENT_NAME)
@View(viewId = VeranstaltungImportSearchView.VIEW_ID, useCase = UseCasePermission.VERANSTALTUNG_IMPORTIEREN)
public class VeranstaltungImportSearchView extends AbstractImportSearchView<List<Veranstaltung>, VeranstaltungExchangeContext> {

  public static final String COMPONENT_NAME = "veranstaltungImportSearchView";

  public static final String VIEW_ID = "/veranstaltung/veranstaltung-import-search.xhtml";

  @Inject
  private VeranstaltungImporter veranstaltungImporter;

  @Inject
  private VeranstaltungImportDescription veranstaltungImportDescription;

  @Inject
  private VeranstaltungExchangeContextFactory veranstaltungExchangeContextFactory;

  @Inject
  private GebietNummerFormatter gebietNummerFormatter;

  public VeranstaltungImportSearchView() {
    super();
  }

  @Override
  @Nullable
  @PreConditionCheck
  public String checkPreCondition() {
    String outcome = super.checkPreCondition();

    if (isBlank(outcome)) {
      if (!isGebietSelected()) {
        return getStartViewId();
      }

      return null;
    }

    return outcome;
  }

  @Override
  protected VeranstaltungExchangeContext getContext() {
    return veranstaltungExchangeContextFactory.createVeranstaltungExchangeContext();
  }

  @Override
  protected ImportDescription getImportDescription() {
    return veranstaltungImportDescription;
  }

  @Override
  protected AbstractImporter<List<Veranstaltung>, VeranstaltungExchangeContext, ? > getImporter() {
    return veranstaltungImporter;
  }

  @Override
  protected DateiImportBerichtCustomData createNewDateiImportBerichtCustomData() {
    return new DateiImportBerichtCustomData();
  }

  public String getGebietName() {
    return gebietNummerFormatter.getName(getContext().getGebiet());
  }
}
